/* DataTypes2.sc: complex datatypes in SpecC	*/
/* -------------				*/

// NOTE: when compiled with the SpecC compiler with -ww,
//	 this file produces lots of warnings;
//	 these warnings are intended!

/*** global scope (depth 0) ***/
int x;
typedef struct S { int a, b; float F; } S;
struct BitFields
	{ int	x : 5;
	  int	  : 8;	/* padding */
	  int	y :10; };
enum E;		/* declaration only */
enum E { A };	/* definition */
enum E;		/* additional declaration */
union U;
union U *Uptr;
S s1, s2;
union U {
	S s1, s2;
	enum E e;
	int x; };

union	/* anonymous union (=> Warning: Useless!) */
{
int a;
float b;
};

/* dependencies */
struct A; struct B; struct C;
struct B { int x; };
struct C { int x; struct B b; int y; struct A *a; };
struct A { int x; struct C c; struct B b; int y; };

/* dependency bug, fixed 07/01/00, R.D. */
typedef struct { char _file; } FILE;
struct dev_vmem { FILE *memfn; };

/* dependency bug "bug_redhat_7_1.sc", fixed 06/05/01, R.D. */
struct bug_scrc10_s
{
  int x;
};
struct bug_scrc10_a
{
  struct bug_scrc10_s d[1];
};
typedef struct bug_scrc10_i
{
  struct bug_scrc10_s d[1];
} bug_scrc10_t;
struct bug_scrc10_a2
{
  struct bug_scrc10_s *d[1];
};
typedef struct bug_scrc10_i2
{
  struct bug_scrc10_s *d[1];
} bug_scrc10_t2;
struct bug_scrc10_x
{
  struct bug_scrc10_x *d[1];
};


behavior DataTypes2(void)
{
   /*** class scope (depth 1) ***/
   int x;
   typedef struct S { int a,b; float F; } S;
   enum E { A, B };

   int i = 42;			// OK
   bit[8] b = 1111000b;		// OK
   int i2[2] = { 0, 1 };	// now supported! (03/29/02, RD)
   const char *s1 = "String";	// OK
   char s2[] = "String";	// now supported! (04/02/02, RD)
   char s3[] = {'S', 't'};	// now supported! (04/02/02, RD)

   void main(void)
   {
   /*** function scope (depth 2) ***/
   int x;
   typedef struct S { int a,b,c; float F; } S;
   enum E { A, B, C };

   while(true)	/* forever */
      {
   /*** inner function scope (depth 3...) ***/
        int *x;
        typedef struct S { int a,b,c,d; float F; } S;
        enum E { A, B, C, D };
        S s1, *s2;

        s1.b = (int) (s1.a + s1.c * (double) s1.F);
        x = &s1.d; *x++;
        s2 = &s1 + sizeof(S) + sizeof(s1.a);
        s1.d = s2->c * (long)s2->F;
       } /* elihw */
   }

};

/*** usertype-local user-types (really nasty cases) ***/

/* (this was a topological sorting bug, FIXED Mar 5, 1999) */
struct X1 { int a, b; };	// X1 must be defined before S!
struct S1 {
	struct {
		struct X1 x;	// (because it is nested (deep) inside)
		int i; } s1;
	int i2; };

/* (this was a "forgotton case" bug, FIXED Mar 7, 1999) */
struct X2 { int a, b; };
struct S2 {
	struct S1 {		// struct S1 is locally defined
		struct X2 x;
		int i; } s1;
	enum E { a, b, c } e;
	struct S1 s2;		// (and must not be defined twice!)
	enum E e2;
	int i2; };

/* (this was another "forgotten case" bug, FIXED June 18, 2000) */
struct StructWithFunctionPointers {
	int ERROR;			// this 'ERROR' is not hidden
	int (*square)(int ERROR);	// by this 'ERROR' argument!
	};

/* (and another one..., FIXED June 21, 2000) */
void ff(int cookie,
	int (*fptr1)(int cookie, int a),	// cookie does not
	int (*fptr2)(int cookie, int b));	// shadow the upper cookie

/* (one more "forgotten case" bug, FIXED June 21, 2000) */
enum memory_map{
	memory_map_p=0,
	// ...
	memory_map_pt,
	// ...
	memory_map_OK = 42,
	memory_map_BUG = memory_map_pt	// self-referencing enum
	};

/* (new shortcut for bit vector types, added 02/12/01) */
bit[8]	byte;
bit[4]	nibble;

/* nasty case, found in sys/siginfo.h (added/fixed 07/13/02, RD) */

typedef struct sigqueue {
        struct sigqueue *sq_next;
//      k_siginfo_t sq_info;
        void (*sq_func)(struct sigqueue *);
        void *sq_backptr;
} sigqueue_t;

/* EOF */
